require "import"
import "android.widget.*"
import "android.content.Intent"
import "android.view.View"
import "android.graphics.BitmapFactory"
import "java.io.File"
import "android.net.Uri"
import "android.os.Environment"
import "luajava"

activity = this

function showToast(message)
    Toast.makeText(activity, message, Toast.LENGTH_SHORT).show()
end

function aboutButton()
    local aboutLayout = {
        ScrollView,
        layout_width = "fill",
        layout_height = "fill",
        backgroundColor = 0xFF121212, -- Warna latar belakang gelap
        {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            layout_height = "wrap",
            padding = "16dp",
            {
                Button,
                text = "Contact Developer",
                layout_width = "fill",
                layout_height = "wrap",
                backgroundColor = 0xFF03DAC5,
                textColor = 0xFF000000,
                padding = "12dp",
                onClick = function()
                    pcall(function()
                        service.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("tg://resolve?domain=jibomico")))
                    end)
                    showToast("Membuka Telegram...")
                    if aboutDlg then aboutDlg.dismiss() end
                end
            },
            {
                Button,
                text = "Bergabung ke channel Telegram",
                layout_width = "fill",
                layout_height = "wrap",
                backgroundColor = 0xFFBB86FC,
                textColor = 0xFFFFFFFF,
                padding = "12dp",
                onClick = function()
                    pcall(function()
                        service.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("tg://resolve?domain=jieshuojm")))
                    end)
                    showToast("Membuka channel Telegram...")
                    if aboutDlg then aboutDlg.dismiss() end
                end
            },
            {
                Button,
                text = "Bergabung ke grup WhatsApp",
                layout_width = "fill",
                layout_height = "wrap",
                backgroundColor = 0xFF6200EE,
                textColor = 0xFFFFFFFF,
                padding = "12dp",
                onClick = function()
                    pcall(function()
                        service.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("https://chat.whatsapp.com/EXsCeLRcy9I3njvaqeIn7x")))
                    end)
                    showToast("Membuka grup WhatsApp..")
                    if aboutDlg then aboutDlg.dismiss() end
                end
            }
        }
    }

    aboutDlg = LuaDialog(activity)
    aboutDlg.setTitle("Developed by Jm")
    aboutDlg.setView(loadlayout(aboutLayout))
    aboutDlg.setButton("Kembali ke beranda", function()
        aboutDlg.dismiss()
    end)
    aboutDlg.show()
end

function showStableDiffusionDialog()
    local function generateAIImageSD(prompt, callback)
        local apiUrl = "https://api.siputzx.my.id/api/ai/stable-diffusion?prompt=" .. prompt
        Http.get(apiUrl, {}, function(code, content)
            if code == 200 then
                callback(nil, content) -- Berhasil: mengembalikan data gambar
            else
                callback("Error: Gagal mengakses API (HTTP " .. code .. ")", nil) -- Gagal: mengembalikan pesan error
            end
        end)
    end

    local function saveImageSD(imageData, customFileName)
        local baseFolderPath = "/sdcard/Download/StableDiffusionImages"
        local folder = File(baseFolderPath)
        if not folder.exists() then folder.mkdirs() end -- Membuat folder jika belum ada

        local fileName = customFileName .. ".png"
        local filePath = baseFolderPath .. "/" .. fileName

        local file = io.open(filePath, "wb")
        if file then
            file:write(imageData) -- Menulis data gambar ke file
            file:close()
            return filePath
        else
            return nil
        end
    end

    local resultDialogSD -- Variabel lokal untuk dialog hasil
    local function showResultDialogSD(message, filePath)
        local resultLayoutSD = {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            layout_height = "wrap_content",
            padding = "16dp",
            {
                TextView,
                text = message,
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp",
                textSize = "16sp"
            },
            {
                Button,
                text = "Unduh",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    if filePath then
                        showToast("Gambar disimpan di: " .. filePath)
                    else
                        showToast("Gagal menyimpan gambar.")
                    end
                end
            },
            {
                Button,
                text = "Tutup",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    resultDialogSD.dismiss()
                end
            }
        }
        resultDialogSD = LuaDialog(activity)
        resultDialogSD.setTitle("Hasil Gambar AI Stable Diffusion")
        resultDialogSD.setView(loadlayout(resultLayoutSD))
        resultDialogSD.show()
    end

    local stableDiffusionLayout = {
        ScrollView,
        layout_width = "fill",
        layout_height = "fill",
        {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            padding = "16dp",
            layout_height = "wrap_content",
            {
                EditText,
                id = "promptInputSD", -- ID unik
                hint = "Masukkan deskripsi gambar yang akan dibuat, contoh: 'buatkan gambar bulan di atas laut'",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            },
            {
                Button,
                id = "generateButtonSD", -- ID unik
                text = "Buat Gambar Stable Diffusion",
                layout_width = "fill",
                layout_height = "wrap_content"
            },
            {
                TextView,
                id = "statusTextSD", -- ID unik
                text = "",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            }
        }
    }

    local stableDiffusionDlg = LuaDialog(activity)
    stableDiffusionDlg.setTitle("Generator AI Stable Diffusion")
    -- PERBAIKAN: Memuat layout. Variabel UI dengan 'id' akan menjadi global secara otomatis.
    local sdView = loadlayout(stableDiffusionLayout)
    stableDiffusionDlg.setView(sdView)

    stableDiffusionDlg.setButton("Kembali", function()
        stableDiffusionDlg.dismiss()
    end)

generateButtonSD.setOnClickListener(function(v)
        local prompt = tostring(promptInputSD.getText())
        if prompt == "" then
            statusTextSD.setText("Masukkan deskripsi gambar terlebih dahulu.")
            return
        end
        statusTextSD.setText("Sedang memproses permintaan...")

        generateAIImageSD(prompt, function(err, imageData)
            if err then
                statusTextSD.setText(err) -- Menampilkan error jika gagal (termasuk Code 429)
            else
                local fileName = prompt:gsub("%s+", "_") -- Mengganti spasi dengan underscore untuk nama file
                local filePath = saveImageSD(imageData, fileName) -- Menyimpan gambar
                statusTextSD.setText("Gambar berhasil dibuat dan ditampilkan!")
                showResultDialogSD("Gambar berhasil dibuat. Anda dapat menyimpan atau menutup dialog.", filePath)
            end
        end)
    end)
    stableDiffusionDlg.show()
end

function showMagicStudioDialog()
    -- Fungsi internal untuk memanggil API Magic Studio
    local function generateAIImageMS(prompt, callback)
        local apiUrl = "https://api.siputzx.my.id/api/ai/magicstudio?prompt=" .. prompt
        Http.get(apiUrl, {}, function(code, content)
            if code == 200 then
                callback(nil, content)
            else
                callback("Error: Gagal mengakses API (HTTP " .. code .. ")", nil)
            end
        end)
    end

    local function saveImageMS(imageData, customFileName)
        local baseFolderPath = "/sdcard/Download/MagicStudioImages"
        local folder = File(baseFolderPath)
        if not folder.exists() then folder.mkdirs() end

        local fileName = customFileName .. ".png"
        local filePath = baseFolderPath .. "/" .. fileName

        local file = io.open(filePath, "wb")
        if file then
            file:write(imageData)
            file:close()
            return filePath
        else
            return nil
        end
    end

    local resultDialogMS
    local function showResultDialogMS(message, filePath)
        local resultLayoutMS = {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            layout_height = "wrap_content",
            padding = "16dp",
            {
                TextView,
                text = message,
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp",
                textSize = "16sp"
            },
            {
                Button,
                text = "Unduh",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    if filePath then
                        showToast("Gambar disimpan di: " .. filePath)
                    else
                        showToast("Gagal menyimpan gambar.")
                    end
                end
            },
            {
                Button,
                text = "Tutup",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    resultDialogMS.dismiss()
                end
            }
        }
        resultDialogMS = LuaDialog(activity)
        resultDialogMS.setTitle("Hasil Gambar AI Magic Studio")
        resultDialogMS.setView(loadlayout(resultLayoutMS))
        resultDialogMS.show()
    end

    local magicStudioLayout = {
        ScrollView,
        layout_width = "fill",
        layout_height = "fill",
        {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            padding = "16dp",
            layout_height = "wrap_content",
            {
                EditText,
                id = "promptInputMS", -- ID unik
                hint = "Masukkan deskripsi gambar yang akan dibuat, contoh: 'potret seorang penyihir'",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            },
            {
                Button,
                id = "generateButtonMS", -- ID unik
                text = "Buat Gambar Magic Studio",
                layout_width = "fill",
                layout_height = "wrap_content"
            },
            {
                TextView,
                id = "statusTextMS", -- ID unik
                text = "",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            }
        }
    }

    local magicStudioDlg = LuaDialog(activity)
    magicStudioDlg.setTitle("Generator AI Magic Studio")
    -- PERBAIKAN: Memuat layout. Variabel UI dengan 'id' akan menjadi global secara otomatis.
    local msView = loadlayout(magicStudioLayout)
    magicStudioDlg.setView(msView)

    magicStudioDlg.setButton("Kembali", function()
        magicStudioDlg.dismiss()
    end)

    generateButtonMS.setOnClickListener(function(v)
        local prompt = tostring(promptInputMS.getText())
        if prompt == "" then
            statusTextMS.setText("Masukkan deskripsi gambar terlebih dahulu.")
            return
        end
        statusTextMS.setText("Sedang memproses permintaan...")

        generateAIImageMS(prompt, function(err, imageData)
            if err then
                statusTextMS.setText(err)
            else
                local fileName = prompt:gsub("%s+", "_")
                local filePath = saveImageMS(imageData, fileName)
                statusTextMS.setText("Gambar berhasil dibuat dan ditampilkan!")
                showResultDialogMS("Gambar berhasil dibuat. Anda dapat menyimpan atau menutup dialog.", filePath)
            end
        end)
    end)
    magicStudioDlg.show()
end

function showDreamshaperDialog()
    -- Fungsi internal untuk memanggil API Dreamshaper
    local function generateAIImageDS(prompt, callback)
        local apiUrl = "https://api.siputzx.my.id/api/ai/dreamshaper?prompt=" .. prompt
        Http.get(apiUrl, {}, function(code, content)
            if code == 200 then
                callback(nil, content)
            else
                callback("Error: Gagal mengakses API (HTTP " .. code .. ")", nil)
            end
        end)
    end

    local function saveImageDS(imageData, customFileName)
        local baseFolderPath = "/sdcard/Download/DreamshaperImages"
        local folder = File(baseFolderPath)
        if not folder.exists() then folder.mkdirs() end

        local fileName = customFileName .. ".png"
        local filePath = baseFolderPath .. "/" .. fileName

        local file = io.open(filePath, "wb")
        if file then
            file:write(imageData)
            file:close()
            return filePath
        else
            return nil
        end
    end

    local resultDialogDS
    local function showResultDialogDS(message, filePath)
        local resultLayoutDS = {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            layout_height = "wrap_content",
            padding = "16dp",
            {
                TextView,
                text = message,
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp",
                textSize = "16sp"
            },
            {
                Button,
                text = "Unduh",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    if filePath then
                        showToast("Gambar disimpan di: " .. filePath)
                    else
                        showToast("Gagal menyimpan gambar.")
                    end
                end
            },
            {
                Button,
                text = "Tutup",
                layout_width = "fill",
                layout_height = "wrap_content",
                onClick = function()
                    resultDialogDS.dismiss()
                end
            }
        }
        resultDialogDS = LuaDialog(activity)
        resultDialogDS.setTitle("Hasil Gambar AI Dreamshaper")
        resultDialogDS.setView(loadlayout(resultLayoutDS))
        resultDialogDS.show()
    end

    local dreamshaperLayout = {
        ScrollView,
        layout_width = "fill",
        layout_height = "fill",
        {
            LinearLayout,
            orientation = "vertical",
            layout_width = "fill",
            padding = "16dp",
            layout_height = "wrap_content",
            {
                EditText,
                id = "promptInputDS", -- ID unik
                hint = "Masukkan deskripsi gambar yang akan dibuat, contoh: 'buatkan gambar kucing'",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            },
            {
                Button,
                id = "generateButtonDS", -- ID unik
                text = "Buat Gambar Dreamshaper",
                layout_width = "fill",
                layout_height = "wrap_content"
            },
            {
                TextView,
                id = "statusTextDS", -- ID unik
                text = "",
                layout_width = "fill",
                layout_height = "wrap_content",
                padding = "10dp"
            }
        }
    }

    local dreamshaperDlg = LuaDialog(activity)
    dreamshaperDlg.setTitle("Generator AI Dreamshaper")
    -- PERBAIKAN: Memuat layout. Variabel UI dengan 'id' akan menjadi global secara otomatis.
    local dsView = loadlayout(dreamshaperLayout)
    dreamshaperDlg.setView(dsView)

    dreamshaperDlg.setButton("Kembali", function()
        dreamshaperDlg.dismiss()
    end)

    generateButtonDS.setOnClickListener(function(v)
        local prompt = tostring(promptInputDS.getText())
        if prompt == "" then
            statusTextDS.setText("Masukkan deskripsi gambar terlebih dahulu.")
            return
        end
        statusTextDS.setText("Sedang memproses permintaan...")

        generateAIImageDS(prompt, function(err, imageData)
            if err then
                statusTextDS.setText(err)
            else
                local fileName = prompt:gsub("%s+", "_")
                local filePath = saveImageDS(imageData, fileName)
                statusTextDS.setText("Gambar berhasil dibuat dan ditampilkan!")
                showResultDialogDS("Gambar berhasil dibuat. Anda dapat menyimpan atau menutup dialog.", filePath)
            end
        end)
    end)
    dreamshaperDlg.show()
end

local mainAppLayout = {
    ScrollView,
    layout_width = "fill",
    layout_height = "fill",
    {
        LinearLayout,
        orientation = "vertical",
        layout_width = "fill",
        padding = "16dp",
        layout_height = "wrap_content",
        {
            TextView,
            text = "Pilih Model AI untuk Membuat Gambar:",
            layout_width = "fill",
            layout_height = "wrap_content",
            textSize = "18sp",
            paddingBottom = "16dp",
            gravity = "center"
        },
        {
            Button,
            text = "Stable Diffusion",
            layout_width = "fill",
            layout_height = "wrap_content",
            layout_marginBottom = "10dp",
            onClick = function()
                showStableDiffusionDialog() -- Memanggil dialog Stable Diffusion
            end
        },
        {
            Button,
            text = "Magic Studio",
            layout_width = "fill",
            layout_height = "wrap_content",
            layout_marginBottom = "10dp",
            onClick = function()
                showMagicStudioDialog() -- Memanggil dialog Magic Studio
            end
        },
        {
            Button,
            text = "Dreamshaper",
            layout_width = "fill",
            layout_height = "wrap_content",
            layout_marginBottom = "20dp",
            onClick = function()
                showDreamshaperDialog() -- Memanggil dialog Dreamshaper
            end
        },
        {
            Button,
            text = "Tentang, Tutorial & Pengaturan",
            layout_width = "fill",
            layout_height = "wrap_content",
            onClick = function()
                aboutButton() -- Memanggil dialog About
            end
        }
    }
}

mainDialog = LuaDialog(activity)
mainDialog.setTitle("Membuat Gambar Dengan AI")
mainDialog.setView(loadlayout(mainAppLayout))

mainDialog.setButton("Tutup", function()
    mainDialog.dismiss()
end)
mainDialog.show()

